
(∫k1+ctxt : dans ce monde devenu hétéroclite, représenter chaque situation de l'agent pour programmer son activité
 (Programmer l'action de l'agent, c'est à la fois le but du codeur et celui de la machine IA qui, ce faisant, apprend.
  (La seule différence, mais elle est de taille : en IA, il faut trouver comment programmer la machine pour qu'elle synthétise du code elle-même.) ) 
 (Précision de vocabulaire : espace d'états du monde ⇔ ensemble de toutes les situations possibles des agents sur le support
  (Dans le cadre ∫k1, le monde devient hétéroclite, précisons la notion de situation dans laquelle l'agent peut se trouver. §/jeuVideo/foragerOnAGrid.png)
  (Chaque situation d'un agent se représente au moyen de la liste des propriétés, relations, fonctions et comportements des entités du MONDE ⊈mobilier+entités⊉.)
  (Note : à l'instar de la construction des univers de Herbrand, par définition, la taile de l'espace d'états du monde ∫k1 est énorme :
   (C'est, construit de façon combinatoire, l'ensemble des situations dans lesquelles le/les agents peuvent se trouver ⊈40^10⊉ §/mond-EtaDu/pionOnIt.png) ) 
  (Monde hétéroclite implique riche. Alors souvent l'agent n'est plus seul : ils sont plusieurs ou nombreux. On ne parle plus de l'agent mais des agents.) ) 
 (Notion de partition récursive d'un ensemble donné : §/parti°/nivo0.png
  (Partitionner un ensemble c'est comme réaliser un puzzle : ⊈récursivement⊉ on le découpe en plusieurs sous-ensembles. Ex : §/parti°/Puzzle.png)
  (Les contraintes à satisfaire : §/parti°/2regPuzzle.png
   (Ne pas perdre/délaisser le moindre morceau, car l'union de ceux obtenus doit totalement reconstituer l'ensemble initial.)
   (Ne pas comptabiliser 2 fois le moindre bout, car les morceaux obtenus doivent être disjoints :
    (Leur intersection 2 à 2 doit toujours être nulle, vide ⊈pas de chevauchement no overlapping⊉.) ) 
   (Pour une partition récursive, on partage séparément chaque morceau obtenu et on effectue ce traitement récursivement.) ) ) 
 (Zoomer/descendre à l'intérieur d'une partition récursive jusqu'à une feuille ⊈terminale⊉
  (Ce parcours génère un contexte imbriqué caractéristique de cette feuille, laquelle correspond à un état du monde.) ) 
 (Un contexte imbriqué pour représenter chaque état du monde, chaque situation possible des agents
  (Rappeler la notion de contexte imbriqué : §/contxt/a.png
   (Ex : hier j'ai rencontré Jo. Il était avec Ana. Nous sommes allé au bar, mais c'était plein. Il a proposé d'aller chez lui, mais elle a préféré un salon de thé.
    (Dans cet exemple, un peu capillotracté, il faut comprendre que Jo=il, lui c'=le bar, Ana=elle, nous=Jo, Ana et moi. §/contxt/txt.png) ) 
   (Ex tiré de Lisp : la même variable 'n' est propagée de plus en plus profondément.
    (C'est la valeur du contexte dans lequel on est qui compte. §/lisp/exec/nice.png) ) ) 
  (Implémentation de ce mécanisme :
   (On peut représenter un zoom, une descente dans une partition récursive au moyen d'une pile de contextes imbriqués)
   (Quand on superpose, intersecte tous les contextes imbriqués correspondants à tous les états possibles du monde, on obtient un arbre ⊈récursif⊉.) ) 
  (3 résultats importants apparaissent :
   (Aspect systématique : un bon programmeur doit se débrouiller pour classer toute situation au bout d'une des feuilles de l'arbre des états de son problème.
    (Dans une programmation par règles de l'activité de l'agent ⊈Σ situation→action-À-Exécuter⊉, chaque situation peut être atteinte/décrite par empilement de contextes.)
    (Comment construire ⊈récursivement⊉ un arbre dont les feuilles constituent une partition de toutes les situations possibles.
     (Avec les grammaires contextuelles, grâce aux contextes imbriqués, toute situation devient repérable, représentable, communicable ou programmable.) ) ) 
   (Aspect codage : la méthode pour partitionner l'espace de états du système ⊈des agents situé ⊈AS⊉⊉
    (Introduire la notion de facettes : ce sont des traits des entités du monde ⊈propriétés relations fonctions⊉. Ex : fatigué⊈Gil⊉, direction⊈Ali, sud⊉. père⊈Tom,Jef⊉.)
    (Il faut décrire chaque état du monde suffisament précisement pour qu'il en soit caractérisé càd unique/distinct
     (Elle est de prendre, convoquer, rajouter aux entités du monde, des facettes clivantes, jusqu'à obtenir une partition récursive des situations possibles.) ) ) 
   (Aspect universel de la représentation : chaque situation possible des AS peut être atteinte/caractérisée
    (Ex 1 basé sur les maths : reprendre l'illustration précédente.
     (Tout d'abord, nous partitionnons cet ensemble pour en faire un puzzle ⊈niveau 1⊉ §/parti°/nivo0.png)
     (Ensuite, récursivement, séparément, nous partageons les sous-ensembles : niveau N §/parti°/Puzzle.png)
     (Puis nous classons dans un arbre, les morceaux obtenus : nous construisons l'arbre des contextes. §/parti°/arBeau.png)
     (Maintenant nous pouvons vérifier qu'après avoir parcouru l'arbre, au bout de chaque feuille est attachée la pièce correspondante. §/parti°/biject°.png) ) ) 
   (Une heuristique importante : aller du général au particulier
    (Définition : une heuristique est une sorte d'axiome, càd une considération qui n'est pas démontrée, mais on constate qu'elle est efficace.)
    (Énoncé de cette heuristique : quand on décrit le contexte d'une action, il faut aller du général au particulier.)
    (C'est ainsi que dans la vie, une histoire structurée selon cette méthode, est plus facilement compréhensible)
    (Ex 2 basé sur le langage naturel : Ma mère raconte ses souvenirs de jeunesse, passée dans une ferme
     ("L'été, pour la fenaison, mon père devait aussi faucher nos prés situés dans la Vallée de la Loire, distante de 8 km. Afin d'éviter les aller-retours, il partait plusieurs jours et dormait sur place. Pour cela, il attelait deux charrettes qu'il chargeait des matériels, outils et provisions nécessaires". )
     (Et ma mère conclut avec malice : "Même s'il n'avait plus de nourriture, il continuait à travailler. Mais il revenait dès qu'il n'avait plus à boire !") ) ) ) ) 
 (Intérêt des contextes imbriqués obtenus
  (Ils permettent de caractériser toutes les situations envisageables de l'agent dans le monde )
  (Quand l'espace des états a été partagé récursivement :
   (Nous classifions récursivement l'espace des états, et obtenons un arbre, une taxinomie : §/parti°/biject°2.png)
   (Rappel : dans une partition de l'espace des situations des agents, à chaque situation/état du monde possible correspond une feuille. §/parti°/biject°2.png
    (Ainsi la somme des feuilles d'un arbre représente la partition des situations/états possibles d'un problème. §/parti°/Puzzle.png) ) 
   (Parcourir cette taxinomie des états, du tronc à une feuille terminale, empile les instanciations qui caractérisent une situation de l'agent, un état du problème
    (Montrons qu'empiler des instanciations, imbrique des contextes ce qui caractérise une situation de l'agent, un état du problème
     (Partons du tronc et grimpons-le pour remonter la branche menant à une feuille cible.)
     (Lelong de ce trajet, à chaque fourche, vu les caractéristiques de la situation, nous choisissons une instanciation correspondant à la branche qui mène à la feuille but)
     (Une fois arrivés à la feuille désignée, le long de ce trajet, nous avons testés et collectées les traits caractéristiques de la situation de l'agent.)
     (Ce faisant en empilant les instanciations, nous avons cerné le contexte correspondant à l'état du monde. §/contxt/1.png)
     (Ainsi, toute feuille d'un arbre peut être caractérisée et atteinte par la donnée du parcours qui mène jusqu'à elle. §/contxt/lieWayPil.png)
     (Cet arbre obtenu en intersectant les situations des agents, correspond aussi à l'intersections des contextes : nous le nommons aussi "arbre des contextes".) ) ) 
   (Aspect programmation : §/parti°/biject°2.png
    (Ayant bien identifé le contexte, càd la situatio de l'agent dans le monde, le codeur attache à la feuille terminale, le programme de comportement à exécuter. §/contxt/1.png) ) ) 
  (Des contextes imbriqués ⊈grammaires contextuelles⊉ pour la représentation, la programmation et l'apprentissage
   (Démarche de programmation du comportement de l'agent situé
    (Soit un agent sur un plateau, il doit analyser sa situation actuelle.
     (Pour ce faire, au vu de ses perceptions, il parcourt l'arbre de ses états, et arrive à la feuille correspondant à sa situation instantanée.) ) 
    (Au bout de cette branche de l'arbre, le codeur a attaché le programme à exécuter
     (Alors c'est ici que l'agent trouve la séquence en rapport, càd la liste des actions adaptées à sa situation.) ) ) 
   (Démarche d'apprentissage du comportement de l'agent situé
    (Avec ∫k 2 ou 3, nous avons vu que l'espace d'états correspond à une matrice.
     (Dans ce cadre, pour l'agent, apprendre c'est, dans chaque case de la matrice, attacher l'instruction à exécuter : il possède la forme d'un symbole. §/sikFood/décisionTab.png) ) 
    (Dans une représentation ∫k1 où l'espace d'états est dispatché, ventilé sur les feuilles de l'arbre des situations, pour l'agent, apprendre c'est :
     (À chaque feuille de l'arbre, attacher l'information correspondante. Avec ∫k1, plus riche, elle présente plutôt la forme d'un arbre structuré. §/netSémantiq/4objCla∫ic.png) ) ) ) 
  (Dans les règles, la généralisation facilite la représentation des connaissances
   (Définir la généralisation dans les règles :
    (C'est remplacer des constantes ⊈des objets ou entités donnés⊉ par des variables ⊈typées⊉.) ) 
   (Aspect pédagogique : ici on explique comment le mécanisme de programmation par variables est implémenté
    (Mais dans ce cadre ⊈partition d'un arbre en N feuilles terminales⊉ il est difficile à comprendre : ce mécanisme est aussi décrit dans le cours sur les moteurs d'inférence d'ordre 1.) ) 
   (Fusionnez les branches, en remplaçant dans leurs fourches, les constantes par des variables typées. Procédez de même dans les feuilles qui décrivent l'action à y effectuer.
    (Ces généralisations restreignent la combinatoire, diminue drastiquement le nombre de branches à décrire et ainsi, simplifient beaucoup la représentation des procès.) ) 
   (Exemple : le déplacement des personnes : §/motor0/NregCumVar.png
    (Soit un lieu où 3 personnes ⊈Gil, Ali et Léa,⊉ évoluent. Combien faut-il écrire de règles pour modéliser leurs déplacements depuis et vers : la cour, le pré et la maison ?)
    (Inutile d'écrire 3x3x3=27 règles : elles peuvent se généraliser au moyen de variables. Ainsi, on n'a plus qu'à décrire une seule règle : qq qui est qqpart va qqAutrePart. ) ) 
   (Exemple : le transport au moyen de conteneur §/teneur/a.JPG
    (Si on met ⊈ou charge⊉ un objet dans un conteneur qu'on déplace du lieu X, jusqu'à Y. )
    (Une fois arrivé au lieu Y, quand on le retire ⊈ou le décharge⊉ du conteneur, on a transporté notre objet de X à Y. )
    (L'efficacité de cette opération est universelle : elle ne varie guère en fonction du contenu. Ici encore l'utilisation des variables simplifie la rédaction des règles à décrire.) ) ) ) ) 