
(Transition de l'automate fini ⊈AF⊉ à l'Agent Situé ⊈AS⊉ : on simule un monde régulier où on simplifie par généralisation
 (Au préalable : définition de l'agent situé :
  (Un agent, c'est la MODÉLISATION abstraite d'un ROBOT càd d'un ordinateur sur pattes ⊈ou plutôt, sur roues⊉. §/robot/u.png)
  (On le qualifie d'agent 'situé' car il est placé en situation de survie dans son monde.)
  (Définition de l'agent situé : pour que cet agent soit actif, on le jette dans un monde où il se trouve en situation de survie. §/agent/02ortho/LesN1rst.png) ) 
 (Initialement : constater la faible puissance de représentation de l'automate fini ⊈∫k3⊉
  (L'AF possède un nombre d'états fini : d'un côté ça simplifie son utilisation, mais de l'autre son exprésivité est faible. §/sequencer/trajets/cheminDeLieux.png
   (Rappel : le synoptique de l'AF est uniquement basé sur les états de son système
    (D'abord l'état de l'automate est aussi celui du système ⊈cf la flèche rouge montante⊉. §/AFini/schema/a.png)
    (De même, l'automate perçoit directement l'état du système ⊈càd ici, l'entrée verticale de sa table, cf la partie horizontale de flèche rouge.)
    (Enfin, par sa 'décision', il détermine le prochain état du système, que sa table présente à l'entrée du registre d'état, mais qui n'entrera qu'avec le prochain pulse de l'horloge) ) 
   (Rappel : nous avons commencé le cours avec le séquenceur et l'AF, tous deux sont des outils formels simples §/systemFormel/SF.png
    (Is sont pratiques, mais ils possèdent une faible représentativité : les mondes simulés sont plats, fades. §/AFini/ex/sncfWst/Pa-Ch-Le-Re.png) ) ) ) 
 (Enrichissons le synoptique de l'AF : plaçons un agent dans un monde
  (Ce monde ajouté qui transforme l'AF et construit un AS, où se positionne-t-il dans le nouveau synoptique. §/agent/00Situe/a.png
   (À chaque instant Δt l'état de l'automate était décrit par un symbole ⊈Ex : '4' ou 'Pau' ...⊉ )
   (Quand on passe à l'AS, ce symbole de l'AF est remplacé par le plateau où est placé l'agent. §/agent/00Situe/les2aside.png)
   (Et autour du plateau, on rajoute un interfaçage en entrée et en sortie.) ) 
  (Situer ce monde en rapport avec la Vie Artificielle ⊈Darwinisme⊉ §/Darwin/cumAApeBody.png
   (Pour que cet agent soit actif, on le stresse : §/memetiq/JfMemSim/paysage.png
    (On utilise l'éclairage de la vie artificielle pour sous-tendre son activité par le besoin de trouver sa subsistance dans son monde.) ) ) 
  (Situer ce monde par rapport à la vie réelle :
   (C'est un monde digitalisé : celui, régulier, idéal des systèmes formels, des jeux digitaux ⊈damier, échec, pions, cartes⊉ §/formel/clefSymbole.png
    (On quitte le monde réel des grandeurs analogiques, pour un monde simplifié : celui du digital. Ex : la grille d'un plateau de jeu de société. §/grid/stresFeromon.bmp) ) 
   (C'est un monde lisse, régulier. En fait il est très lisse, très régulier
    (Certaines lois physiques sont abandonnées :
     (Les déplacements y sont outrageusement simplifés
      (Souvent dans ce modèle, soit un pion est bloqué, soit il est libre : on ne distingue pas de situation intermédiaire. §/memetiq/JfMemSim/2batarSpecy.bmp)
      (Les déplacements s'y font sans résistance, sans friction.) ) 
     (Les distances y sont très simplifiées : souvent le type de déplacement codé passe seulement l'agent dans la case à côté ⊈et c'est tout, point final⊉ §/agent/11puls°/hysteSoma/alterner/all.png)
     (Les directions de déplacement sont réduites à 4 : nord/sud, est/ouest.)
     (La troisième dimension est carrément ignorée : rarement le jeu se développe en hauteur §/logo3D/dual.png) ) 
    (Le monde, le cadre de l'activité est infiniment régulier :
     (Les lois du déplacement sont constantes sur toute l'étendue du plateau.)
     (On trouve seulement certains jeux d'aventure, plus complexes, où on va de lieu à lieu. On entre dans une salle et tout change :
      (Alors le joueur tombe dans l'eau, ou se retrouve dans un désert aride, un marécage boueux ... §/saga/imgDAccueil.png) ) ) ) ) ) 
 (Présentons ce nouveau synoptique de l'AS où on introduit une représentation d'un monde plus complexe
  (Du point de vue de l'AS : maintenant son synoptique de PROCÈS de L'INFO devient : '' perception-décision-action '' §/agent/00Situe/gridSimple.png
   (En entrée de l'agent, on ajoute une interface 'perception' : à chaque instant Δt ses capteurs scannent la partie du monde située devant lui.)
   (Au milieu, on ajoute une interface 'décision' : l'agent traite sa perception et décide de l'action à effectuer maintenant dans son monde.)
   (En sortie : on trouve la simulation d'un monde complexe où l'action est effectuée. §/agent/00Situe/a.png) ) 
  (Décrivons le nouveau synoptique de l'agent dans SON MONDE
   (L'agent situé est construit à partir du synoptique de l'automate fini
    (C'est un outil mathématique simple à mettre en oeuvre, mais doté d'un faible pouvoir de représentation : les mondes qu'il simule sont plats, fades !) ) 
   (Pour construire l'AS, nous introduisons cette couche profonde qui induit des traitements doublement interfacés, tamponnés §/agent/00Situe/les2aside.png
    (En entrée du monde, càd la flèche rouge vers le bas : l'AS décide et ordonne son action sur le plateau.)
    (En sortie, càd la flèche rouge vers le haut : le monde remonte son état. Ceci fournit une nouvelle perception à l'agent qui ainsi décide, adapte sa prochaine action.) ) 
   (Note : même si d'un côté il est plus complexe à simuler, pour simplifier, on commence par introduire un monde très régulier.
    (C'est un monde géométrique, standardisé, normalisé : ⊈support de n² cases, table, plan dans ℜ²⊉. §/6ppv/gridDeDiam.bmp)
    (Mais ça suffit : l'intérêt est que, dès qu'on introduit cet interface, le joueur reconnaît les conventions et y projette son imaginaire. §/saga/session1.png) ) 
   (Quel travail effectuer pour coder cette interface, càd modéliser, simuler cet agent mis en situation sur un plateau de cases ?
    (Il faut décrire la grille et chaque case : sa nature ⊈ressource, obstacle ou support ⊈dans ce cas, on doit préciser son contenu⊉⊉. §/sikFood/dix1erPas.png)
    (Il faut l'interfacer, càd décrire l'agent mobile et préciser son comportement : lui dire ce qu'il perçoit et interpréter ses actions sur le plateau. §/sikFood/decisionTab.png
     (En fonction de ses actions, il faut : le tourner, l'avancer et déplacer les objets qu'il bouge, faire apparaître ceux qu'il pose, disparaître ceux qu'il mange ... §/memetiq/JfMemSim/paysage.png) ) 
    (On ajoute des actionneurs que l'agent active, et une interface qui simule l'effet du procès correspondant sur l'état du monde ⊈prend pose tourne mange ...⊉ §/sikFood/t.png) ) ) ) 
 (Avec ce nouvel agent ⊈l'AS⊉, que devient la représentation des scènes statiques du monde
  (L'agent est placé sur un plateau de cases, un conteneur 2D qui constitue un interfaçage de son activité. §/sikFood/t.png
   (L'agent ne perçoit pas directement l'état du monde, mais seulement son ENVIRONNEMENT : une SCÈNE de taille réduite par l'effet d'horizon. §/sikFood/dix1erPas.png)
   (Contrairement à l'AF qui décidait instantanément car il restituait le contenu de sa table 2D, chez l'AS, la prise de décision est temporisée.
    (Pour prendre sa décision, avant de définir quelle action effectuer, l'agent RÉFLÉCHIT : il analyse sa perception. §/agent/0reactif/pilotParmiObstac.png) ) 
   (De même, l'action en situation est complexifiée par le tamponnement induit par le support où l'agent est situé :
    (Maintenant l'état du monde est complexe, il n'est plus question que l'AS décide dans quel nouvel état il va se trouver : §/actionner/b.png)
    (Il décide seulement de ses actions. Et l'interprétation de chacune change quelques relations au sein du mobilier de son monde. §/netSemantiq/proces.png) ) ) 
  (L'AS permet une richesse des représentations
   (Intérêt de cette richesse des situations potentiellement induites par le passage à l'agent situé :
    (Rappel : chez l'automate, le nombre des situations était fini. Par définition, c'était le nombre d'états du système : càd en fait qu'il était petit. §/rtr/graf/1.bmp)
    (Mais avec l'AS, le nombre des situations possibles devient immense ⊈presque infini⊉ ce qui induit une grande diversité des activités descriptibles. §/mond-EtaDu/big1/5.png
     (En conséquence, L'AS devient un outil de modélisation intéressant pour les jeux, la pédagogie, les documentaires, la communication ...) ) ) ) 
  (Mais on tombe sur le pb de vacuité, d'ÉVANESCENCE du tableau : souvent, quand sa taille grandit, il se creuse
   ( Cependant ici, nous devons pointer un inconvénient induit par la richesse de ces représentations
    (Quand le monde de l'agent grandit, on ne peut plus le représenter en EXTENSION, càd au moyen de tableaux de relations, fonctions ...)
    (Pour toucher du doigt ce pb, comparons la représentation d'une relation au sein des deux systèmes ⊈Automate Fini Vs Agent Situé⊉) ) 
   (Représentation d'une relation entre états au sein du système constitué par un Automate Fini ⊈AF⊉
    (Notons A l'ensemble des N états d'un AF. Soit aℜb la relation entre deux états a et b de cet AF.
     (Il nous faut donc une table de N² cases pour représenter le produit cartésien AℜA)
     (Sur une table de NxN = N² cases, la relation AℜA peut se représenter en marquant l'intersection correspondante càd ligneA-colonneB.) ) 
    (Ex : soit l'itinéraire reliant 5 villes : ''Paris Chartres Le Mans Angers Nantes'' §/sncfWst/parisNant.png
     (Ainsi, sur ce trajet, on peut représenter la relation : ''Ville1 estAvant Ville2'' par ce tableau 5x5 : §/rela°/isAvant.png)
     (De même, sur ce trajet, on peut représenter la relation : ''Ville1 estAprès Ville2'' par ce tableau 5x5 : §/rela°/isAfter.png)
     (Sur ce trajet, on peut encore représenter la relation : ''Ville1 estLiéeÀ Ville2'' par ce tableau 5x5 : §/rela°/liaison.png)
     (On peut même représenter la relation : ''Ville1 estLiéeÀ Ville2'' en dessinant une flèche à l'intersection. On obtient ce tableau 5x5 : §/rela°/fleche.png) ) ) 
   (Ici, passons à la représentation du monde de l'AS : utilisons un tableau 2D pour représenter une relation entre des entités du monde
    (Ex 1 : soit un agent 'magenta' positionné dans un corridor de 4 cases jaunes : 0, 1, 2 et 3. §/rela°/c.png
     (Voici, au moyen d'un tableau, la représentation de la relation ''estSuccesseurDe'' sur ce support de 4 cases. §/rela°/succ4.png
      (Pour coder 3 relations nous utilisons 16 cases. Ce qui donne un rapport d'efficacité de 3/16.)
      (Et voici la représentation pour la relation ''estPrédécesseurDe'' correspondante. §/rela°/pred4.png) ) ) 
    (Ex 2 : la notion de tableau CREUX apparait quand N le nombre d'éléments d'un tableau croit d'un rapport k. Note : alors il comporte kN éléments
     (Soit un agent 'magenta' positionné dans un corridor de 8 cases jaunes : 0, 1 ... 8. §/rela°/1.png)
     (Voici, au moyen d'un tableau, la représentation de la relation ''estSuccesseurDe'' sur ce couloir de 4 cases. §/rela°/succ8.png
      (Et voici la représentation pour la relation ''estPrédécesseurDe'' correspondante. §/rela°/pred8.png) ) 
     (Conclusion : on observe une croissance au carré : dans ce cas, le nombre de cases, qui était N² croit d'un rapport K² et devient K²N².
      (De même nous notons que le tableau se creuse : le ratio d'efficacité devient 7/64 : il a presque été divisé par 2.) ) ) 
    (Ex 3 : sur une carte de 29 villes du grand ouest de la France, on représente le trajet ''Paris St-Nazaire'' §/tabCreux/itineraire.png
     (Voici, au moyen d'un tableau de 29x29=841 cases, la représentation de ce trajet. constatez à quel point il est creux : 5/841 §/tabCreux/B.png) ) ) ) 
  (Pour éviter ce pb de tableau creux : abandonner la représentation EXTENSIVE pour s'inspirer du langage naturel et choisir une représentation en COMPRÉHENSION
   (La représentation des relations entre les entités du monde de l'agent ne peut se faire au moyen d'un tableau exhaustif de relations. §/rela°/cuisine.png)
   (Il faut passer à une représentation ∫k1 plus souple faite au moyen de listes ⊈représentation en compréhension qui requiert l'allocation dynamique de mémoire⊉)
   (Ainsi on utilise plutôt la représentation décentralisée et amorphe de la liste de prédicats : ⊈sous⊈Chaise, Table⊉, àCôté⊈Table, Mur⊉⊉ §/mond-EtaDu/ptiCol/3D+netR.png)
   (Ex : Dans une scène plus riche, représenter 30 relations entre 100 objets requiert 30 tableaux de 100x100 cases = 300 K cases !) ) 
  (Ce faisant on redécouvre les résultats, démarches classiques du langage naturel : on qualifie cette méthode de '' description en compréhension ''
   (C'est celle pointée et consacrée au fil de l'histoire par les logiciens, linguistes, grammairiens ⊈scolastique, Frege ⊈logique vs logistique⊉⊉...)
   (Plus riche, elle requiert plus de place pour coder un prédicat, mais comme elle ne représente que les relations effectives, on obtient une compression de données.) ) ) 
 (Conséquences pour les scènes : avec ce nouvel '' agent situé '' que devient la représentation de son activité ?
  (Richesse des actions. ∫k2 nous fournit l'appel de S/Prog, donc nous pouvons donner de l'épaisseur aux applications composées : §/chaise/assembler.png
   (En utilisant des objets assemblés, on rajoute une couche : on obtient un support, un plateau où on simule l'activité d'un agent plus riche. §/agent/00Situe/a.png) ) 
  (Les supports réguliers ⊈chemin de cases, table, repère cartésien ℜ²⊉ introduisent une simplification par translation
   (La régularité du support introduit une régularité : les relations et traitements ne changent pas en fonction du lieu où les agents les effectuent
    (Cette régularité du support induit une INVARIANCE SPATIALE des RELATIONS et TRAITEMENTS inter-entités §/mondRegulierVsHeteroclit/v.png)
    (Note : on se souvient que c'est aussi le principe de l'expérience scientifique ⊈cf Claude Bernard⊉ ; elle peut être reproduite en un lieu quelconque, à n'importe quel moment.) ) 
   (Pour illustrer cet aspect : voici quelques exemples d'applications bien régulières. Ici, elles sont basées sur des déictiques :
    (Dans un corridor, l'agent avance, quand il voit une case libre devant lui. §/agent/1Dcorridor/1.bmp)
    (Pour bouger sur un plateau, face à un obstacle, l'agent qui voit une case libre sur sa droite, tourne à droite. §/agent/00Situe/8caseCycle.png)
    (Dans un couloir, l'agent mange la pièce de nourriture qu'il trouve devant lui. Et elle disparaît. §/agent/1Dcueiller/foodDisapearesWhenEaten.png) ) 
   (Conclusion : dans un monde régulier où les RELATIONS et TRAITEMENTS inter-entités varient peu :
    (Le comportement des agents peut être plus facilement généralisé, ce qui en simplifie la programmation : §/agent/07Tropic/forager/a.png)
    (Dans un code, employer des déictiques ne le rend pas forcément contingent :
     (Au contraire, il demeure indépendant du contexte. Ex du colon : Moi, maintenant je te déclare que nous allons établir notre ferme ici !) ) ) ) ) 
 (Conclusion : l'agent situé modélise mieux l'activité du monde que ne le faisait l'automate
  (Il représente l'activité d'agents situés sur un support. Cette représentation du monde est plus souple que celle de l'AF. §/plateau/pionOnIt.png)
  (Donc, l'AS modélise de façon plus réaliste le monde quotidien de l'être humain.) ) 
 (Jalon pour la suite : le langage naturel nous montre la voie
  (Il nous invite à utiliser la liste, un média en compréhension. En effet, souple et puissante, elle est pratique, adaptée pour décrire des scènes de la vie active de l'AS.)
  (Nous la retrouverons avec ∫k1 et l'ordinateur. §/mond-EtaDu/big1/5.png) ) ) 