
(Systèmes experts ⊈SE⊉, Moteurs d'inférence d'ordre 1 : exemples d'applications basées sur les règles de production
 (Faire la différence entre : règles de réécriture vs production
  (Règle de réécriture : on réécrit à l'identique ⇒ seulement possible avec des constantes : réécriture.)
  (Règle de production : on produit en grande quantité en instanciant = remplacer les variables par des constantes ⇒ production.) ) 
 (Exemples mathématiques : calculer quelques dérivées de base
  (Notion de dérivée : c'est la pente des étapes de montagne du tour de France §/derivee/ex.png
   (Quand un char d'assaut monte une pente à 100% ça ne veut pas dire qu'il grimpe à un mur... )
   (Mais plutôt qu'il monte une pente à 45°. §/derivee/drive_03.png)
   (Dans l'équation y=αx+b d'une droite le coefficient α correspond à la tangente de l'angle. Or tg⊈90°⊉ = 1 = 100%. §/derivee/Ex1.png) ) 
  (Présenter les dérivées calculées : §/deriv/nEx/va.png)
  (Présenter quelques séquences de calcul remarquables
   (Calculer la dérivée d'un produit de constantes
    (Énoncée du problème à résoudre et explication des convention d'écriture :
     (Il s'agit de calculer la dérivée d'un produit : ⊈3*4⊉' = ⊈dérivée ⊈* 3 4⊉ _x⊉ : dérivée ⊈<de ceci> <par rapport à cela>⊉) ) 
    (Voici les règles de dérivation utilisées :
     (Dérivée d'un produit de fonctions [U*V]' → [U'*V]+[U*V']
      (⊈derivee ⊈* _u _v⊉ _x⊉ → ⊈+ ⊈* ⊈derivee _u _x⊉ _v⊉⊈* _u ⊈derivee _v _x⊉⊉ ⊉ §/deriv/UxV.png) ) 
     (La dérivée d'une constante est nulle
      (⊈derivee 3 _x⊉ → 0 )
      (⊈derivee 4 _x⊉ → 0) ) 
     (Règles de simplification par l'élément neutre de l'opération
      (⊈+ 0 _x⊉ → _x)
      (⊈* 0 _x⊉ → 0 ) ) ) 
    (On obtient cette session : §/deriv/3x4/ses°sansUnif.png)
    (Voici la même avec les indications de l'unificateur. §/deriv/3x4/ses°cumUnif.png) ) 
   (Calculer la dérivée de -cos⊈x⊉. §/trigo/cos.png
    (Énoncée du problème à résoudre. Il s'agit de calculer la dérivée d'une fonction circulaire : -cos⊈x⊉' = ⊈dérivée ⊈- ⊈cos _x⊉ _x⊉⊉)
    (Voici les règles de dérivation utilisées :
     (Dérivée d'une composition de 2 fonctions : Z⊈Y⊈x⊉⊉
      (⊈derivee ⊈_z _y⊉ _x⊉ → ⊈* ⊈derivee ⊈_z _y⊉ _y⊉ ⊈derivee _y _x⊉ ⊉ : [Z⊈y⊉]'x → [Z⊈y⊉]'y * [Y⊈x⊉]'x : c'est vraiment abstrait !)
      (Notez seulement qu'en utilisant la notation différentielle c'est plus simple : dZ/dx = dZ/dY * dY/dx ⇔ [Z⊈y⊉]'x → [Z⊈y⊉]'y * [Y⊈x⊉]'x) ) 
     (Dérivée de la fonction -x :
      (⊈derivee ⊈- _x⊉ _x⊉ → -1) ) 
     (Règle de simplification
      (⊈* 1 _x⊉ → _x : multiplication par l'élément neutre de la multiplication.)
      (⊈* ⊈- _x⊉ _y⊉ → ⊈- ⊈* _x _y⊉⊉ : ⊈-x⊉y → -xy : pour les noeuds binaires : faire remonter les signes moins des profondeurs, vers le haut de l'arbre : il vont disparaître.)
      (⊈- ⊈- _x⊉⊉ → ⊈+ _x⊉ : - - x → x : pour les noeuds unaires : simplifier les signes moins.)
      (⊈+ _u⊉ → _u : l'addition unaire d'une constante se réduit à cette même constante.) ) ) 
    (La session obtenue est : §/deriv/moinsCosX/ses°sansUnif.png)
    (Voici la même avec les indications de l'unificateur. §/deriv/moinsCosX/ses°cumUnif.png) ) ) 
  (Présenter des exemples illustrant la définition initiale de l'I. A. : exécuter des procès qui demandent de l'intelligence
   (Celle qui a été arrêtée par l'équipe de Mc Carthy, en 1956, au Dartmouth College, à Hanover, dans le New Hampshire
    (Définition de l'IA : c'est quand la machine effectue un traitement qui aurait été qualifié d'intelligent s'il avait été exécuté par l'homme.) ) 
   (Illustrons cette intelligence de la machine par 3 exemples, où, dans un domaine ponctuel, elle dépasse l'homme
    (Ex1 : la calculatrice de l'écolier
     (L'homme est battu par la machine à cause de la faiblesse de sa mémoire de travail.)
     (Et, quand il dispose de crayon/papier, il réussit à effectuer le traitement, cependant, il y passe bien plus de temps.) ) 
    (Ex2 : le compilateur Fortran de John Backus, Peter Naur
     (La déclaration de John Backus à ce sujet est très explicite :
      (This period was the most exciting of our life, the compiler was finding some optimisations we would never think in. §/compiler/synoptiq3.png) ) ) 
    (Ex3 : JFL qui voulait ralentir un programme C en y rajoutant des instructions inutiles, mais ça ne marchait pas...
     (...car le compilateur, voyant que ces instructions étaient inutiles, les virait.) ) 
    (Ex4 : le compilateur dans la structure ''case of cas1, cas2 ... cas n'' : parfois il affiche une mise en garde : tous le cas ne sont pas prévus''
     (Et nous, quand on analyse les ''cas1, cas2 ... casN'' on ne comprend pas pourquoi. Et en fait, on finit par tropuver l'erreur et admettre qu'il a raison !) ) ) ) ) 
 (Focaliser sur ce dernier exemple : je vous ai déniché une bonne bouteille de derrière les fagots, mais je ne recommencerai pas tous les jours
  (Essayez de réaliser que ce truc est magnifique.
   (Ce n'est pas tous les jours que vous verrez un pareil monument de la BOVIA ⊈bonne vielle IA⊉. ) ) 
  (D'abord, la forme la plus simple : exp⊈x²⊉
   (La session brute, avec les explications de l'unificateur. §/deriv/exp_X2/cumUnif.png)
   (La session explicitée au moyen du graphisme. §/deriv/exp_X2/ses°+reg.png)
   (Même session avec en plus un rappel du jeu de règles. §/deriv/exp_X2/ses°Net.png) ) 
  (Enfin, exp⊈-x²⊉ : la loi Normale
   (C'est la courbe de Gauss, très importante en statistiques. §/exp/exp-x2.png)
   (Ce procès requiert la dérivation d'une fonction composée : un calcul difficile car assez abstrait.)
   (Le calcul de la dérivée de exp⊈-x²⊉ : §/deriv/exp-X2/ses°Brut.png) ) 
  (Démontrer le fait que 2+3=5
   (Approche 1 : vérifier le fait que "2+3=5"
    (Si j'utilise une calculatrice, une table de multiplication ou ma mémoire, je peux donc confirmer que " 2+3=5 ".)
    (Mais ce n'est qu'une vérification !) ) 
   (Mais, on peut énoncer : " un jour implique toujours "
    (Ayant vérifié une fois, le fait "2+3=5", on peut argumenter et généraliser pour démontrer que 2+3=5.)
    (En effet, on peut avancer que : Vrai un jour implique vrai toujours. C'est à dire arguer de l'universalité spatiale et temporelle du fait " 2+3=5 ".)
    (Ceci nous permet de conclure qu'il est vrai quelque soit le temps et le lieu, et qu'il suffit de le vérifier quelque part une fois, pour démontrer, pour toujours et partout, la règle " 2+3=5 ". CQFD.) ) ) 
  (Autre démontration de la règle "2+3 = 5" en transcrivant le problème à un niveau plus fin : celui du composant
   (Solution 1 : démontrer la règle dans une représentation en base binaire
    (Étape 'aller' : Conversion décimal→ binaire, càd la représenter au moyen de deux symboles : {0, 1}.)
    (Étape intermédiaire de calcul : elle peut être effectuée de 3 différentes façons
     (1⊉ Sur un papier, transposer l'addition en 10+11=101 et la calculer. §/adder/2+3=5.png)
     (2⊉ Au moyen du simulateur logique :
      (Poser et calculer l'addition 10+11=101 au moyen d'un simulateur logique : §/logSim/adder2+3=5.png)
      (Ainsi, pour effectuer le calcul, l'adder 3 bits applique les règles d'addition transposées en binaire. §/adder/3b/8rules-2col.png) ) 
     (3⊉ Solution rapide : au moyen d'une table d'addition ⊈2D en binaire⊉ faire le calcul 10+11 = 101.)
     (4⊉ Solution loyale : au moyen d'une UAL calculant en série ⊈Cochemez, Dalmo FPA de Champs/Marne⊉.
      (Puisqu'on effectue le calcul en série, on n'utilise qu'un seul additionneur 3 entrées ⊈acuA acuB retenue⊉ - une sortie pour le résultat.) ) ) 
    (Étape retour : conversion binaire→ décimal du résultat : 101→5.) ) 
   (Solution 2 : démontrer la règle dans une représentation en base unaire
    (Quelques explications sur cette représentation des nombres
     (Elle est basée sur un seul symbole, laissé au choix de l'utilisateur. Choisissons le bâton vertical : '|'.
      (Pour représenter le nombre N, on met N symboles dans un sac : Ex. pour 2 = ⊈| |⊉, Ex. pour 3 = ⊈| | |⊉.)
      (Ainsi nous procédons à l'instar d'un berger qui compte ses moutons en les mettant en bijection avec des cailloux qu'il conserve dans un sac.)
      (Remarque : en latin, caillou se dit calculus, c'est de là qui viennent les terminologies 'calcul reinal' et la notion mathématique de 'calcul'.) ) 
     (Autre solution : faire comme Péano, composer récursivement la fonction 'succ' §/Peano/reg/conver°B10-B1succ.png) ) 
    (Démonstration 'à la main' :
     (Sur un papier, dessiner l l bâtons, puis l l l, et calculer le résultat de l'addition : l l l l l. On déduit : l l + l l l = l l l l l )
     (Sur une table, faire la manip : poser | | vis, puis | | | vis. Finalement on obtient | | | | | vis.) ) 
    (Démonstration au moyen d'un moteur 1
     (Poser l'addition : l l + l l l = l l l l l et l'effectuer au moyen d'une concaténation :
      (Le code du programme exécuté : §/motor1/cumUnair/code2+3=5.png)
      (La session obtenue à l'écran : §/motor1/cumUnair/trace2+3=5.png) ) 
     (Poser et calculer l' addition : suc⊈suc⊈0⊉⊉ +suc⊈suc⊈suc⊈0⊉⊉⊉ = suc⊈suc⊈ suc⊈suc⊈ suc⊈0⊉⊉⊉⊉⊉
      (Montrer le principe de la numération au moyen de 'succ'
       (Règles pour convertir de décimal à unaire : §/Peano/reg/conver°B10-B1succ.png) ) 
      (Traiter ainsi l'exemple 2+3 : d'abord l'ordi le réécrit succ⊈succ⊈succ⊈2⊉⊉⊉
       (Départ avec une formule de prof 3 : §/Peano/1sequ/0-2x3nivoSansLien.png)
       (Ajouter des liens pour montrer sa structure : §/Peano/1sequ/1-2x3nivoCumLien.png)
       (On part depuis cette formule à 3 niveaux : §/Peano/1sequ/2-goD1ExpA3nivo.png)
       (Une règle réécrit la feuille succ⊈2⊉→3 : §/Peano/1sequ/3-regToGoDeNiv3A2.png)
       (Après ça on a une formule à 2 niveaux : §/Peano/1sequ/4-1subst°-niv2.png)
       (Une règle réécrit la feuille succ⊈3⊉→4 : §/Peano/1sequ/5-regToGoDeNiv2A1.png)
       (Après celà, il ne reste qu'un unique niveau : §/Peano/1sequ/6-2subst°-niv1.png)
       (Une règle réécrit la feuille succ⊈4⊉→5 : §/Peano/1sequ/7-regToGoDeNiv1A0.png)
       (Puis on arrive au nombre final : §/Peano/1sequ/9-3subst°-niv0.png) ) 
      (Code du programme exécuté : §/Peano/reg/code2+3=5.png)
      (Session simplifiée obtenue à l'écran : §/Peano/ses°/2+3sansUnif.png)
      (Session détaillée obtenue à l'écran : §/Peano/ses°/2+3cumUnif.png) ) ) ) ) ) ) 